/*
  Demonstrates the memory locations of various parts of a program.

  Orion Sky Lawlor, olawlor@acm.org, 2005/3/23 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

int some_global;

int main() {
	int *some_ptr=(int *)0x09048000;
	int *lil_heap=(int *)malloc(sizeof(int));
	int *big_heap=(int *)malloc(1024*1024*sizeof(int));
	printf("Location of:\n"
		"Stack=%p\n"
		"Code(main)=%p\n"
		"Code(printf)=%p\n"
		"Global=%p\n"
		"Dll(errno)=%p\n"
		"Heap (small)=%p\n"
		"Heap (big)=%p\n",
		&some_ptr,
		main,
		printf,
		&some_global,
		&errno,
		lil_heap,
		big_heap
	);
		
	return 0;
}
